****************************************************************************
***                          Module box : Jeu                            ***
****************************************************************************

	xdef	nouveau,box_status
	xdef	jeux,init_box,score
	
	xref	levels,data
	xref	locate
	xref	partie,initirq,temps
	xref	sortie,winner,affiche_push_button
	xref	affiche_nouveau,affiche_score,affiche_winner
	

****************************************************************************
	include	declare.s
* Constantes
TIME_OUT	equ	1600
NB_LVL		equ	3
DIM_Y		equ	21
DIM_X		equ	10
DEB_Y		equ	7
DEB_X		equ	27
GOOD_BOX	equ	48 * 168
BAD_BOX		equ	79 * 255
VIDE		equ	32
PLACE		equ	42 * 183
MUR		equ	35

****************************************************************************
	sect	prog,,c
	
init_box
	move.b	#0,numero
	move.b	#1,box_status
	rts


jeux	move.b	#1,box_status	* Le programme peut tre interrompu
	cmp.b	#2,partie	* La partie doit tre rinitialise
	bne	jeux2
	move.b	#1,partie
	jsr	nouveau	
jeux2	jsr	inca		* Fleche : ESC[A ESC[B ESC[C ESC[D
	cmp.b	#'Q',d0
	beq	sortie
	cmp.b	#'q',d0
	beq	sortie
	cmp.b	#'',d0	* Touche invalide
	bne	jeux2
	jsr	inca
	cmp.b	#'n',d0		* Check code...
	beq	next_lvl
	cmp.b	#'[',d0		* Touche invalide
	bne	jeux2
	jsr	inca		* On vide le tampon
	move.b	#0,box_status	* Le programme ne doit plus tre interrompu
	cmp.b	#'C',d0
	beq	droite
	cmp.b	#'D',d0
	beq	gauche
	cmp.b	#'B',d0
	beq	bas
	cmp.b	#'A',d0
	beq	haut
	bra	jeux

droite	move.b	y,y1
	move.b	y,y2
	move.b	x,d0
	add.b	#1,d0
	move.b	d0,x1	* case ou on veut aller : x1, y1
	add.b	#1,d0
	move.b	d0,x2	* case suivant celle o on veut aller : x2, y2
	bra	avancer

gauche	move.b	y,y1
	move.b	y,y2
	move.b	x,d0
	sub.b	#1,d0
	move.b	d0,x1
	sub.b	#1,d0
	move.b	d0,x2
	bra	avancer
	
haut	move.b	x,x1
	move.b	x,x2
	move.b	y,d0
	sub.b	#1,d0
	move.b	d0,y1
	sub.b	#1,d0
	move.b	d0,y2
	bra	avancer

bas	move.b	x,x1
	move.b	x,x2
	move.b	y,d0
	add.b	#1,d0
	move.b	d0,y1
	add.b	#1,d0
	move.b	d0,y2
	bra	avancer
	
avancer
	* On regarde si on peut aller sur la case suivante
	move.b	y1,d1
	move.b	x1,d2
	jsr	myx
	cmp.b	#VIDE,d0
	beq	ok
	cmp.b	#PLACE,d0
	beq	ok
	cmp.b	#MUR,d0
	beq	jeux
	
	* Ici, Il y'a une caisse sur la case
	move.b	d0,d3	* On sauvegarde d0

	* On regarde si on peut pousser la caisse
	move.b	y2,d1
	move.b	x2,d2
	jsr	myx
	cmp.b	#MUR,d0
	beq	jeux
	cmp.b	#GOOD_BOX,d0
	beq	jeux
	cmp.b	#BAD_BOX,d0
	beq	jeux
	
	* Ici, on peut pousser la caisse
	* On augmente le score de 1
 	move.w	score,d5
 	add.w	#1,d5
 	move.w	d5,score

	jsr	affiche_score

	move.b	#VIDE,d4    * Caractre  afficher  l'emplacement de la caisse
	cmp.b	#BAD_BOX,d3 * La caisse etait-elle mal place ?
	beq	blanc1
	move.b	caisse,d5
	add.b	#1,d5
	move.b	d5,caisse
	move.b	#PLACE,d4   * Caractre  afficher  l'emplacement de la caisse

blanc1	move.b	d0,d5
	move.b	#BAD_BOX,d0 * Type de caisse  afficher
	cmp.b	#VIDE,d5    * La caisse va-t-elle mal se placer ?
	beq	blanc2
	move.b	caisse,d5
	subi.b	#1,d5
	move.b	d5,caisse
	move.b	#GOOD_BOX,d0 * Type de caisse  afficher

blanc2
	* On affiche la caisse et on modifie la matrice
	jsr	loc
	jsr	set_myx
	jsr	outch

	* On efface la caisse et on modifie la matrice
	move.b	y1,d1
	move.b	x1,d2
	jsr	loc
	move.b	d4,d0
	jsr	set_myx
	jsr	outch
	bra	ok
	
ok
	* On place le curseur  la bonne position
	move.b	y1,d1
	move.b	x1,d2
	jsr	loc
	move.b	d1,y
	move.b	d2,x
	
	* On regarde si on a fini le niveau
	cmp.b	#0,caisse
	bne	jeux

* Niveau suivant
next_lvl
	jsr	affiche_winner
	jsr	affiche_push_button
	move.b	y,d1
	move.b	x,d2
	jsr	loc

	move.b	numero,d0
	add.b	#1,d0
	move.b	d0,numero
	cmp.b	#NB_LVL,d0
	beq	winner
	
	move.b	#3,partie
attend	cmp.b	#1,partie	# On attend un appuit sur le boutton poussoir
	bne	attend

	bra	jeux

* Procdure myx : renvoie d0.B=M(y,x) y=d1.b x=d2.b
myx	lea	level,a5
	clr.w	d0
	move.b	d1,d0
	mulu.w	#DIM_Y,d0
	and.w	#$FF,d2
	add.w	d2,d0
	move.b	(a5,d0),d0
	rts

* Procdure set_myx : Fait M(y,x)=d0.B y=d1.b x=d2.b
set_myx	move.w	d7,-(SP)
	lea	level,a5
	clr.w	d7
	move.b	d1,d7
	mulu.w	#DIM_Y,d7
	and.w	#$FF,d2
	add.w	d2,d7
	move.b	d0,(a5,d7)
	move.w	(SP)+,d7
	rts

* Prend d1 et d2 comme arguments,
* place le curseur  la colonne d1+DEB_Y et la ligne d2+DEB_X
loc	movem.w	d0-d2,-(SP)
	add.b	#DEB_Y,d1
	add.b	#DEB_X,d2
	move.b	d1,-(SP)
	move.b	d2,-(SP)
	jsr	locate
	add.l	#4,SP
	movem.w	(SP)+,d0-d2
	rts


* Procdure nouveau : Commence un nouveau jeu
nouveau
	* Initialisation des variables
	move.w	#TIME_OUT,temps
	move.w	#0,score
	
	lea	data,a5
	clr.w	d0
	move.b	numero,d0
	mulu.w	#3,d0
	move.b	(a5,d0),y
	move.b	1(a5,d0),x
	move.b	2(a5,d0),caisse

	* Matrice de jeu
	clr.w	d2
	move.b	numero,d2
	mulu.w	#DIM_X*DIM_Y,d2
	lea	level,a0
	lea	levels,a5
	move.w	#DIM_X*DIM_Y-1,d0
remplit	move.w	d2,d1
	add.w	d0,d1
	move.b	(a5,d1),(a0,d0)
	dbra	d0,remplit

	* Affichage du niveau
	jsr	affiche_nouveau
	lea	level,A0
	clr.b	d1
	clr.b	d2
bl	jsr	loc
	move.w	A0,A5
	JSR	pdata
	add.w	#DIM_Y,A0
	add.b	#1,d1
	cmp.b	#DIM_X,d1
	bne	bl

	* On place le curseur  la bonne position
	move.b	y,d1
	move.b	x,d2
	jsr	loc
	rts
	

**************************************************************************
	sect	data,,d

* Variables
level	ds.b	DIM_X*DIM_Y * La matrice du level
y	ds.b	1	* ligne, position du curseur
x	ds.b	1	* colonne, position du curseur
x1	ds.b	1	* colonne de la case o on veut aller
y1	ds.b	1	* ligne de la case o on veut aller
x2	ds.b	1	* colonne de la case o on veut pousser la caisse
y2	ds.b	1	* ligne de la case o on veut pousser la caisse
caisse	ds.b	1	* nb de caisse  placer : caisse = 0 <==> on gagne
score	ds.w	1	* nb de fois ou on a deplac une caisse
numero	ds.b	1	* numro du level en cours
box_status ds.b	1	* Communication avec les interruptions :
			* =1 : le programme peut tre interromput
			*      (appel de la procdure nouveau, par exemple)
			* =0 : Le programme ne doit pas tre interrompu.
